# Generated by the protocol buffer compiler.  DO NOT EDIT!
# Source: google/cloud/clouddms/v1/clouddms.proto for package 'Google.Cloud.CloudDMS.V1'
# Original file comments:
# Copyright 2021 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

require 'grpc'
require 'google/cloud/clouddms/v1/clouddms_pb'

module Google
  module Cloud
    module CloudDMS
      module V1
        module DataMigrationService
          # Database Migration service
          class Service

            include GRPC::GenericService

            self.marshal_class_method = :encode
            self.unmarshal_class_method = :decode
            self.service_name = 'google.cloud.clouddms.v1.DataMigrationService'

            # Lists migration jobs in a given project and location.
            rpc :ListMigrationJobs, ::Google::Cloud::CloudDMS::V1::ListMigrationJobsRequest, ::Google::Cloud::CloudDMS::V1::ListMigrationJobsResponse
            # Gets details of a single migration job.
            rpc :GetMigrationJob, ::Google::Cloud::CloudDMS::V1::GetMigrationJobRequest, ::Google::Cloud::CloudDMS::V1::MigrationJob
            # Creates a new migration job in a given project and location.
            rpc :CreateMigrationJob, ::Google::Cloud::CloudDMS::V1::CreateMigrationJobRequest, ::Google::Longrunning::Operation
            # Updates the parameters of a single migration job.
            rpc :UpdateMigrationJob, ::Google::Cloud::CloudDMS::V1::UpdateMigrationJobRequest, ::Google::Longrunning::Operation
            # Deletes a single migration job.
            rpc :DeleteMigrationJob, ::Google::Cloud::CloudDMS::V1::DeleteMigrationJobRequest, ::Google::Longrunning::Operation
            # Start an already created migration job.
            rpc :StartMigrationJob, ::Google::Cloud::CloudDMS::V1::StartMigrationJobRequest, ::Google::Longrunning::Operation
            # Stops a running migration job.
            rpc :StopMigrationJob, ::Google::Cloud::CloudDMS::V1::StopMigrationJobRequest, ::Google::Longrunning::Operation
            # Resume a migration job that is currently stopped and is resumable (was
            # stopped during CDC phase).
            rpc :ResumeMigrationJob, ::Google::Cloud::CloudDMS::V1::ResumeMigrationJobRequest, ::Google::Longrunning::Operation
            # Promote a migration job, stopping replication to the destination and
            # promoting the destination to be a standalone database.
            rpc :PromoteMigrationJob, ::Google::Cloud::CloudDMS::V1::PromoteMigrationJobRequest, ::Google::Longrunning::Operation
            # Verify a migration job, making sure the destination can reach the source
            # and that all configuration and prerequisites are met.
            rpc :VerifyMigrationJob, ::Google::Cloud::CloudDMS::V1::VerifyMigrationJobRequest, ::Google::Longrunning::Operation
            # Restart a stopped or failed migration job, resetting the destination
            # instance to its original state and starting the migration process from
            # scratch.
            rpc :RestartMigrationJob, ::Google::Cloud::CloudDMS::V1::RestartMigrationJobRequest, ::Google::Longrunning::Operation
            # Generate a SSH configuration script to configure the reverse SSH
            # connectivity.
            rpc :GenerateSshScript, ::Google::Cloud::CloudDMS::V1::GenerateSshScriptRequest, ::Google::Cloud::CloudDMS::V1::SshScript
            # Retrieve a list of all connection profiles in a given project and location.
            rpc :ListConnectionProfiles, ::Google::Cloud::CloudDMS::V1::ListConnectionProfilesRequest, ::Google::Cloud::CloudDMS::V1::ListConnectionProfilesResponse
            # Gets details of a single connection profile.
            rpc :GetConnectionProfile, ::Google::Cloud::CloudDMS::V1::GetConnectionProfileRequest, ::Google::Cloud::CloudDMS::V1::ConnectionProfile
            # Creates a new connection profile in a given project and location.
            rpc :CreateConnectionProfile, ::Google::Cloud::CloudDMS::V1::CreateConnectionProfileRequest, ::Google::Longrunning::Operation
            # Update the configuration of a single connection profile.
            rpc :UpdateConnectionProfile, ::Google::Cloud::CloudDMS::V1::UpdateConnectionProfileRequest, ::Google::Longrunning::Operation
            # Deletes a single Database Migration Service connection profile.
            # A connection profile can only be deleted if it is not in use by any
            # active migration jobs.
            rpc :DeleteConnectionProfile, ::Google::Cloud::CloudDMS::V1::DeleteConnectionProfileRequest, ::Google::Longrunning::Operation
          end

          Stub = Service.rpc_stub_class
        end
      end
    end
  end
end
